
import random
import numpy as np
import pdb

def lookup(words,w):
    w = w.lower()
    if w in words:
        return words[w]
    else:
        return words['UUUNKKK']

class example(object):

    def __init__(self, context, target, ov, rlt, intr, words = None, params=None):
        self.context = context.strip()
        self.target = target.strip()
        self.ov = ov/10.
        self.rlt = rlt/10.
        self.intr = intr/10.
        self.embeddings_context = []
        self.embeddings_target = []
        self.context_toks = self.context.split()
        self.target_toks = self.target.split()
        if params and params.ngrams:
            self.populate_embeddings_ngrams(self.embeddings_context, self.context, words, params.ngrams)
            self.populate_embeddings_ngrams(self.embeddings_target, self.target, words, params.ngrams)
        self.populate_embeddings(self.embeddings_context, self.context, words)
        self.populate_embeddings(self.embeddings_target, self.target, words)

        #features
        self.features = []

    def populate_embeddings(self, em, text, words):
        text = text.lower()
        arr = text.split()
        for i in arr:
            em.append(lookup(words,i))

    def populate_embeddings_ngrams(self, em, text, words, size):
        phrase = " " + text.lower() + " "
        for j in range(len(phrase)):
            ngram = phrase[j:j+size]
            if len(ngram) != size:
                continue
            em.append(lookup(words, ngram))
        if len(em) == 0:
            em = [words['UUUNKKK']]
